[X,Y]=ndgrid(linspace(0,2.5*pi,40),linspace(0,2.5*pi,50));
f=@(x,y) sin(x).*cos(y);
fd=f(X,Y);

% Plot eines 3D-Meshs
figure(1)
mesh(X,Y,fd)
xlabel('x'),  ylabel('y'),  zlabel('f')
title('f(x,y)=sin(x)cos(y)')
axis tight

colorbar

% Plot eines 3D-Meshs mit abweichenden Colorbar-Daten
figure(2)
CO=X.^2.*cos(Y);
mesh(X,Y,fd,CO)
xlabel('x'),  ylabel('y'),  zlabel('f')
title('f(x,y)=sin(x)cos(y)')
axis tight

c=colorbar;
c.Label.String = 'g(x,y)=x^2cos(y)';

% Plot einer 3D-Oberfläche mit abweichenden Colorbar-Daten
figure(3)
surf(X,Y,fd,CO)
% xlabel('x'),  ylabel('y'),  zlabel('f')
% title('f(x,y)=sin(x)cos(y)')
axis tight

colorbar
colormap('jet')

% Plot einer 3D-Oberfläche mit Contourlinien
figure(4)
surfc(X,Y,fd)
% xlabel('x'),  ylabel('y'),  zlabel('f')
% title('f(x,y)=sin(x)cos(y)')
axis tight

colorbar
colormap('hsv')

% Plot einer 3D-Oberfläche mit dichtem Gitter
[X,Y]=ndgrid(linspace(0,2.5*pi,400),linspace(0,2.5*pi,500));
f=@(x,y) sin(x).*cos(y);
fd=f(X,Y);

figure(5)
surf(X,Y,fd)
% xlabel('x'),  ylabel('y'),  zlabel('f')
% title('f(x,y)=sin(x)cos(y)')
axis tight
colorbar

figure(6)
surf(X,Y,fd,EdgeColor="none")
% xlabel('x'),  ylabel('y'),  zlabel('f')
% title('f(x,y)=sin(x)cos(y)')
axis tight
colorbar

% Beispiel Shading
[X,Y]=ndgrid(0:2,0:2);
f=@(x,y) x.*y;
fd=f(X,Y);

figure(7)
surf(X,Y,fd)
axis tight
colorbar

figure(8)
surf(X,Y,fd,FaceColor="flat")
axis tight
colorbar

figure(9)
surf(X,Y,fd,FaceColor="interp")
axis tight
colorbar